#!/usr/bin/env groovy

import org.apache.log4j.BasicConfigurator
import org.apache.log4j.Level
import org.apache.log4j.Logger

import org.apache.commons.httpclient.*
import org.apache.commons.httpclient.methods.*;
import org.apache.commons.httpclient.auth.AuthScope;
import java.net.URI;
import com.urbancode.air.XTrustProvider;

XTrustProvider.install();


BasicConfigurator.resetConfiguration()
BasicConfigurator.configure()
Logger.getRootLogger().setLevel(Level.ERROR)

final def workDir = new File('.').canonicalFile
final def inputPropsFile = new File(args[0])
final def outputPropsFile = new File(args[1])

final def props = new Properties()
try {
    props.load(new FileInputStream(inputPropsFile))
}
catch (IOException e) {
    throw new RuntimeException(e)
}

String encodePath(String path) {
    String result;
    URI uri;
    try {
        uri = new URI(null, null, path, null);
        result = uri.toASCIIString();
    }
    catch (Exception e) {
         println e.getMessage();
         result = path;
    }
    return result;
}

def anthillUrl      = props['anthillUrl']
final def anthillUser     = props['anthillUser']
final def anthillPassword = props['anthillPassword']
final def buildLifeId     = props['buildLifeId']
final def statusName = props['statusName'];
def message = props['message'];
message = "Assignment from uDeploy - " + message;

while (anthillUrl.endsWith("/")) {
     anthillUrl = anthillUrl.substring(0, anthillUrl.length() - 1);
}

final def fullUrl = anthillUrl + "/rest2/buildlife/${buildLifeId}/statuses?" + 
                               "statusName=" + encodePath(statusName) + "&" +
                               "message=" + encodePath(message);
println fullUrl;

HttpClient client = new HttpClient()
client.getParams().setAuthenticationPreemptive(true);
Credentials defCreds = new UsernamePasswordCredentials(anthillUser, anthillPassword);
client.getState().setCredentials(AuthScope.ANY, defCreds);

PostMethod method = new PostMethod(fullUrl);
int status = client.executeMethod(method);
if (status == HttpStatus.SC_OK || status == HttpStatus.SC_CREATED) {
    println "Successfully assigned status ${statusName}";
}
else {
    throw new Exception(String.format("%d %s", status, HttpStatus.getStatusText(status)));
}

